//**************************************************************************************************
//*  FRIDA: fast reliable interactive data analysis
//*  (C) Joachim Wuttke 1990-, v2(C++) 2001-
//*  http://apps.jcns.fz-juelich.de/frida
//**************************************************************************************************

//! \file  variables.hpp
//! \brief Declares class SVariRegistry.

#ifndef VARIABLES_H
#define VARIABLES_H

#include <map>
#include "../trivia/singleton.hpp"
#include "defs.hpp"
#include "ptr.hpp"

//! Registry for variable objects.

class SVariRegistry : public triv::ISingleton<SVariRegistry>
{
private:
    std::map<const string, RObj> Map; //! unsorted hash, for expression evaluation

public:
    RObj find(const string& key) const;
    RObj find_or_fail(const string& key) const;

    void display_all() const;

    void register_scalar(const string& key, RObj val);
    bool undef(const string& key);
    std::map<const string, string> to_sMap() const;
};

#endif // VARIABLES_H
